<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('QualityManagement.ZjItem.name')" prop="name">
        <el-input
          v-model="formData.name"
          :placeholder="t('QualityManagement.ZjItem.placeholderName')"
        />
      </el-form-item>
      <el-form-item :label="t('QualityManagement.ZjItem.zjType')" prop="zjType">
        <el-select
          v-model="formData.zjType"
          clearable
          filterable
          :placeholder="t('QualityManagement.ZjItem.placeholderZjType')"
        >
          <el-option
            v-for="item in typeList"
            :key="item.id"
            :label="item.name"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('QualityManagement.ZjItem.tool')" prop="tool">
        <el-input
          v-model="formData.tool"
          :placeholder="t('QualityManagement.ZjItem.placeholderTool')"
        />
      </el-form-item>
      <el-form-item :label="t('QualityManagement.ZjItem.standardVal')" prop="standardVal">
        <el-input
          v-model="formData.standardVal"
          :placeholder="t('QualityManagement.ZjItem.placeholderStandardVal')"
        />
      </el-form-item>    
      <el-form-item :label="t('QualityManagement.ZjItem.upperVal')" prop="upperVal">
        <el-input
          v-model="formData.upperVal"
          :placeholder="t('QualityManagement.ZjItem.placeholderUpperVal')"
        />
      </el-form-item>
      <el-form-item :label="t('QualityManagement.ZjItem.lowerVal')" prop="lowerVal">
        <el-input
          v-model="formData.lowerVal"
          :placeholder="t('QualityManagement.ZjItem.placeholderLowerVal')"
        />
      </el-form-item>
      <el-form-item :label="t('QualityManagement.ZjItem.unit')" prop="unitId">
        <el-select
          v-model="formData.unit"
          clearable
          :placeholder="t('QualityManagement.ZjItem.placeholderUnit')"
          class="w-1/1"
        >
          <el-option
            v-for="unit in unitList"
            :key="unit.id"
            :label="unit.name"
            :value="unit.id"
          />
        </el-select>
      </el-form-item>
      <el-form-item :label="t('QualityManagement.ZjItem.remark')" prop="remark">
        <el-input
          v-model="formData.remark"
          :placeholder="t('QualityManagement.ZjItem.placeholderRemark')"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">
        {{ t('common.ok') }}
      </el-button>
      <el-button @click="dialogVisible = false">
        {{ t('common.cancel') }}
      </el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { ZjItemApi, ZjItemVO } from '@/api/mes/zjitem'
import {ZjTypeApi, ZjTypeVO} from "@/api/mes/zjtype";
import { ProductUnitApi, ProductUnitVO } from '@/api/erp/product/unit'

/** 质量管理-检验项目 表单 */
defineOptions({ name: 'ZjItemForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const unitList = ref<ProductUnitVO[]>([]) // 产品单位列表
const typeList = ref<ZjTypeVO[]>([]) // 列表
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  zjType: undefined,
  name: undefined,
  remark: undefined,
  tool: undefined,
  standardVal: undefined,
  unit: undefined,
  upperVal: undefined,
  lowerVal: undefined,
})
const formRules = reactive({
  name: [{ required: true, message: t('QualityManagement.ZjItem.validatorNameRequired'), trigger: 'blur' }],
  zjType: [{ required: true, message: t('QualityManagement.ZjItem.validatorZjTypeRequired'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  typeList.value = await ZjTypeApi.getZjTypeList()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await ZjItemApi.getZjItem(id)
    } finally {
      formLoading.value = false
    }
  }
  // 产品单位
  unitList.value = await ProductUnitApi.getProductUnitSimpleList()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as ZjItemVO
    if (formType.value === 'create') {
      await ZjItemApi.createZjItem(data)
      message.success(t('common.createSuccess'))
    } else {
      await ZjItemApi.updateZjItem(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    zjType: undefined,
    name: undefined,
    remark: undefined,
    tool: undefined,
    standardVal: undefined,
    unit: undefined,
    upperVal: undefined,
    lowerVal: undefined,
  }
  formRef.value?.resetFields()
}


</script>
